<?php

namespace Dashboard\Controller;

use Application\Controller\RestAPIClientController;
use Zend\View\Model\{
    ViewModel,
    JsonModel
};
use Dashboard\Form\{
    BookingHistorySearchForm,
    BookingClientSearchForm,
    BookingDriverSearchForm,
    BookingGeneralSearchForm,
    BookingLocationSearchForm,
    BookingPaymentSearchForm,
    BookingStatusSearchForm,
    BookingVehicleSearchForm
};
use Zend\Json\Json;
use Zend\Session\Container;
use Zend\Debug\Debug;

class BookingHistoryController extends RestAPIClientController {

    public function indexAction() {
        $data = [];
        $tab_type = "";
        BookingGeneralSearchForm:: $bookingType = $this->getPackageTypeList();
        $form = new BookingGeneralSearchForm();
        $request = $this->getRequest();
         if ($request->isPost()) {
            $form->setData($request->getPost());
            $post = $request->getPost()->toArray();
            $tab_type=(isset($post['tab_type']))? $post['tab_type']:'';
            if (!empty($post)) {

                //echo'<pre>';print_r($post);die();
                $data = $post;
               /* $data=[
                    'booking_id'=> $post['booking_id'],
                    'vehicle_owner'=>$post['vehicle_owner'],
                    'booking_type'=>$post['booking_type'],
                    'driver_name'=>$post['driver_name'],
                    'initial_since'=>$post['initial_since'],
                    'initial_to'=>$post['initial_to'],
                    'partner_name'=>$post['partner_name'],

                    'first_name'=>$post['first_name'],
                    'client_rating'=>$post['client_rating'],
                    'last_name'=>$post['last_name'],
                    'mobile_no'=>$post['mobile_no'],
                    'client_id'=>$post['client_id'],
                    'email'=>$post['email'],

                    'first_name'=>$post['first_name'],
                    'driver_rating'=>$post['driver_rating'],
                    'last_name'=>$post['last_name'],
                    'email'=>$post['email'],
                    'driver_id'=>$post['driver_id'],
                    'mobile_no'=>$post['mobile_no'],
                    'external_reference'=>$post['external_reference'],

                    'vehicle_type'=>$post['vehicle_type'],
                    'license_plate'=>$post['license_plate'],
                    'external_reference'=>$post['external_reference'],

                    'country_id'=>$post['country_id'],
                    'pickup'=>$post['pickup'],
                    'city_id'=>$post['city_id'],
                    'drop_location'=>$post['drop_location'],

                    'booking_status'=>$post['booking_status'],
                    'order_time'=>$post['order_time'],

                    'payment_type'=>$post['payment_type'],
                    'is_paid'=>$post['is_paid'],

                    ];*/
                $data= array_filter($data);
                $bookingHistory = $this->getBookingSearchData($data);
            }
        }else{
            $bookingHistory = $this->getBookingHistoryData($data);
        }

        $bookingHistoryListing = $bookingHistory;
        $viewModel = new ViewModel(['form' => $form, 'bookingHistoryListing' => $bookingHistoryListing, 'tab_type' => $tab_type]);
        return $viewModel;
    }

    /**
     * search
     * @return ViewModel
     */
    public function searchBookingHistoryAction() {
        $data = [];
        $postData = $this->getRequest()->getPost()->toArray();
        $data = array_filter($postData);
        $bookingHistory = $this->getBookingSearchData($data);
        //echo '<pre>';print_r($bookingHistory);die();
        $viewModel = new ViewModel(['bookingHistoryListing' => $bookingHistory]);
        $viewModel->setTemplate('/dashboard/booking-history/booking-history-listing');
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    public function clientTabAction() {

        $clientrating = [
            '1' => '*',
            '2' => '**',
            '3' => '***',
            '4' => '****',
            '5' => '*****'
        ];
        BookingClientSearchForm::$clientrating = $clientrating;
        $request = $this->getRequest();

        if ($request->isPost()) {

            $post = $request->getPost()->toArray();
            //echo'<pre>';print_r($post);die();
            $tab_type = (isset($post['tab_type'])) ? $post['tab_type'] : '';
        }

        $form = new BookingClientSearchForm();
        $viewModel = new ViewModel(['form' => $form,'tab_type'=>$tab_type]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * dateTimeBookingType...
     * @return ViewModel
     */
    public function dateTimeBookingTypeAction() {
        //write code here...

        if ($request->isPost()) {

            $post = $request->getPost()->toArray();
            $tab_type = (isset($post['tab_type'])) ? $post['tab_type'] : '';
        }

        $form = new BookingClientSearchForm();
        $viewModel = new ViewModel(['form' => $form,'tab_type'=>$tab_type]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * driverTab...
     * @return ViewModel
     */
    public function driverTabAction() {
        //write code here...

        $driverrating = [
            '1' => '*',
            '2' => '**',
            '3' => '***',
            '4' => '****',
            '5' => '*****'
        ];
        $request = $this->getRequest();
        if ($request->isPost()) {

            $post = $request->getPost()->toArray();
            $tab_type = (isset($post['tab_type'])) ? $post['tab_type'] : '';
        }
        BookingDriverSearchForm::$driverrating = $driverrating;
        $form = new BookingDriverSearchForm();
        $viewModel = new ViewModel(['form' => $form]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * generalTab...
     * @return ViewModel
     */
    public function generalTabAction() {
        BookingGeneralSearchForm:: $bookingType = $this->getPackageTypeList();
        $form = new BookingGeneralSearchForm();
        //$form->setData($bookinggeneral);

        $viewModel = new ViewModel(['form' => $form]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * listingOfBooking...
     * @return ViewModel
     */
    public function listingOfBookingAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * locationTab...
     * @return ViewModel
     */
    public function locationTabAction() {
        //write code here...
        BookingLocationSearchForm:: $stateList = $this->getStateList();
        $form = new BookingLocationSearchForm();
        $viewModel = new ViewModel(['form' => $form]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * paymentTab...
     * @return ViewModel
     */
    public function paymentTabAction() {
        //write code here...

        $paymenttype = [
            '1' => 'Cash',
            '2' => 'Credit'
        ];
        BookingPaymentSearchForm::$paymenttype = $paymenttype;

        $ispaid = [
            '1' => 'Yes',
            '2' => 'No'
        ];
        BookingPaymentSearchForm::$ispaid = $ispaid;

        $form = new BookingPaymentSearchForm();
        $viewModel = new ViewModel(['form' => $form]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * statusTab...
     * @return ViewModel
     */
    public function statusTabAction() {
        BookingStatusSearchForm:: $bookingstatus = $this->getCabStatusList();
        $ordertime = [
            '1' => 'morning',
            '2' => 'evening',
            '3' => 'night'
        ];
        BookingStatusSearchForm::$ordertime = $ordertime;


        $form = new BookingStatusSearchForm();
        $viewModel = new ViewModel(['form' => $form]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /**
     * vehicleTab...
     * @return ViewModel
     */
    public function vehicleTabAction() {
        BookingVehicleSearchForm:: $vehicletype = $this->getVehicleTypeList();
        $form = new BookingVehicleSearchForm();
        $viewModel = new ViewModel(['form' => $form]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }


    public function getPackageTypeList() {
        $packageTypeJsonDataArray = [];
        $url = $this->apiUrl() . "/package";
        $resp = $this->get($url);
        $packageTypeJsonData = Json::decode($resp->getBody(), true);
        foreach ($packageTypeJsonData['data'] as $res) {
            $packageTypeJsonDataArray[$res['id']] = $res['name'];
        }
        return $packageTypeJsonDataArray;
    }

    public function getBookingHistoryData($data) {

        $url = $this->apiUrl() . "/booking/bookingList";
        $resp = $this->post($url, $data);        
        $bookingList = Json::decode($resp->getBody(), true);
        $result = [];
        if($bookingList['responsedata']['status']=='success'){
           $result  = $bookingList['responsedata']['data'];
        }        
        return $result;
    }

    public function getBookingSearchData($data) {

        $url = $this->apiUrl() . "/booking/bookingListSearch";
        $resp = $this->post($url, $data);
        // echo'<pre>';print_r($resp);die();
        $bookingList = Json::decode($resp->getBody(), true);
        $result = [];
        if($bookingList['responsedata']['status']=='success'){
           $result  = $bookingList['responsedata']['data'];
        }        
        return $result;
    }

    public function bookingListAction() {
        $data = [];
        $val = $this->getRequest()->getPost();
        $date = $val['date'];
        $hour = $val['hour'];
        $booking_type = $val['booking_type'];
        $data = ['pickup_date' => $date, 'pickup_time' => $hour, 'booking_type' => $booking_type];
        $bookingHistory = $this->getBookingHistoryData($data);
        $bookingHistoryListing = $bookingHistory;
        $viewModel = new ViewModel(['bookingHistoryListing' => $bookingHistoryListing]);
        $viewModel->setTemplate('dashboard/booking-history/booking-history-listing.phtml');
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    public function daysWiseAction() {
        $data = [];
        $hour_list = [];
        $booking_type = [];
        $val = $this->getRequest()->getPost();
        $date = $val['date'];
        $hour = $val['hour'];
        $url = $this->apiUrl() . "/booking/daywisecount?date=" . $date . '&hour=' . $hour;
        $resp = $this->get($url);
        $val = Json::decode($resp->getBody(), true);

        $url1 = $this->apiUrl() . "/booking/packagewisecount?date=" . $date . '&hour=' . $hour;
        $resp1 = $this->get($url1);
        $val1 = Json::decode($resp1->getBody(), true);

        //echo '<pre>';print_r($val1['responsedata']);die();
        $data = ['pickup_date' => $date];
        $bookingHistory = $this->getBookingHistoryData($data);
        $bookingHistoryListing = $bookingHistory['data']['responsedata'];
        $total_booking = count($bookingHistoryListing);
        foreach ($val['responsedata'][0] as $row) {
            $hour_list["hour_" . $row['hour']] = $row['no_of'];
        }

        foreach ($val1['responsedata'][0] as $row1) {
            $booking_type[] = [
                'booking_type' => $row1['booking_type'],
                'no' => $row1['no']
            ];
        }
        //print_r($hour_list); exit;
        $data = [
            "hour" => $hour_list,
            'total_booking' => $total_booking,
            "booking_type" => $booking_type
        ];
        //return array('hour' => $hour_list, 'hour_wise' => $hour_wise_list, 'booking_type' => $booking_type);
        $view = new JsonModel($data);
        return $view;
    }

    public function getVehicleTypeList($data = null) {
        $vehicleTypeJsonDataArray = [];
        $val = '{"where": {"status": {"neq": 2}}}';
        $val = rawurlencode($val);
        $url = $this->apiUrl() . "/vehicle-type?&filter=" . $val;
        $resp = $this->get($url);
        $vehicleTypeJsonData = Json::decode($resp->getBody(), true);
        foreach ($vehicleTypeJsonData as $res) {
            $vehicleTypeJsonDataArray[$res['id']] = $res['vehicle_type'];
        }
        return $vehicleTypeJsonDataArray;
    }

    /**
     * Get State List
     * @return JSON
     */
    public function getStateList() {
        $stateJsonDataArray = [];
        $country_id = 101;
        $val = '{"where": {"country_id": "' . $country_id . '%"}}';
        $val = rawurlencode($val);
        $url = $this->apiUrl() . "/state?&filter=" . $val;
        $resp = $this->get($url);
        $stateJsonData = Json::decode($resp->getBody(), true);
        foreach ($stateJsonData as $res) {
            $stateJsonDataArray[$res['id']] = $res['name'];
        }
        return $stateJsonDataArray;
    }

    public function getCabStatusList() {
        $statusJsonDataArray = [];
        $status_type = 'cab';
        $val = '{"where": {"type":"'.$status_type.'"}}';
        $val = rawurlencode($val);
        $url = $this->apiUrl() . "/cab-status?&filter=" . $val;
        $resp = $this->get($url);
        $statusJsonData = Json::decode($resp->getBody(), true);
        foreach ($statusJsonData as $res) {
            $statusJsonDataArray[$res['status_id']] = $res['status'];
        }
        return $statusJsonDataArray;
    }
    
    // Created By pt Start--
    
    public function tripDetailsListAction() {
        
        $getid=[];
        $data=[];
        $request = $this->getRequest();
        if ($request->isPost()) {
            
        $getid = $request->getPost()->toArray();  
  
        $url = $this->apiUrl() . "/outstation/getMulticityTripDetail?req=" . $getid['id'];
        $resp = $this->get($url);
        $statusJsonData = Json::decode($resp->getBody(), true);
        
        if(!empty($statusJsonData) && isset($statusJsonData['responsedata']['data'])){
        $data =$statusJsonData['responsedata']['data'];
        }      
        }
       $viewModel = new ViewModel(['data' => $data ]);
        $viewModel->setTemplate('/dashboard/booking-history/trip-detail');
        $viewModel->setTerminal(true);
        return $viewModel;
    }
    
     // Created By pt End--

}
