<?php

namespace Dashboard\Controller;

use Application\Controller\RestAPIClientController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;
use Zend\Json\Json;
use Zend\Config\Config;
use Zend\Config\Factory;
use Dashboard\Model\Booking;

class IndexController extends RestAPIClientController {

    public function __construct() {
        $this->bookingModel =    new Booking();
    }

    /**
     * index
     * @return ViewModel
     */
    public function indexAction() {
        $data = [];
        $data1 = [];
        $dataCredit = [];
        $dataWallet = [];
        $sessionUser = new Container('userlogin');
        $loginData = $sessionUser->userData;
        //echo '<pre>';print_r($sessionUser->userData);die();
        $user_id = $loginData['user_id'];
        $userTypeId = $loginData['user_type_id'];
        $name = $loginData['first_name'];
        $email = $loginData['email'];
        $mobile = $loginData['mobile'];
        $address = isset($loginData['address'])? $loginData['address']:'';
        $referralKey = $loginData['referral_key'];

        if ($userTypeId != 6565) {
            $dataCredit = [];
            $dataWallet = [];
        } else {
            $dataCredit = ['id' => $user_id, 'user_type_id' => $userTypeId];
            $dataWallet = ['id' => $user_id];
        }
        $dataWallet = ['id' => $user_id];

        //
        //echo '<pre>';print_r($dataWallet);die();
        //call API
        $current = 50;
        //call API
        $future = 10;
        //call API
        $completed = 39;
        //call API
        $pending = 46;
        //call API
        $canceled = 23;
        //call API
        $total = 184;

        //call API
        $personalDetails = [
            'first_name' => $name,
            'email' => $email,
            'mobile' => $mobile,
            'address' => $address,
            'referal_key' => $referralKey,
            'company_name' => 'null'
        ];
        //call API

        $data = ['pickup_date' => date('Y-m-d')];
        $data1 = ['pickup_date' => date('Y-m-d'), 'unassigned_booking' => 1];
        $creditBalance = $this->bookingModel->getCreditBalance($dataCredit);
        $recentBookings = $this->bookingModel->getRecentBookings($data);
        $unassignedBookings = $this->bookingModel->getRecentBookings($data1);
        $walletHistory = $this->bookingModel->getWalletPoint($dataWallet);
        $viewModel = new ViewModel([
            'current' => $current,
            'future' => $future,
            'completed' => $completed,
            'pending' => $pending,
            'canceled' => $canceled,
            'total' => $total,
            'personalDetails' => $personalDetails,
            'creditBalance' => $creditBalance['responsedata'],
            'recentBookings' => $recentBookings,
            'unassignedBookings' => $unassignedBookings,
            'walletHistory' => $walletHistory['responsedata']
        ]);
        return $viewModel;
    }

    public function setconfigurationAction() {
        $sessionUser = new Container('userlogin');
        $loginData = $sessionUser->userData;
        $user_id = $loginData['user_id'];
        $comp_id = $loginData['company_id'];
        $compData = $this->getCompanySetupDetails($comp_id);

        $filename = getcwd() . '/config/autoload/customconfig.php';
        $configFile = Factory::fromFile($filename);
        $configFile['site_name'] = $compData['site_name'];
        $configFile['site_title'] = $compData['site_title'];
        $configFile['global_email'] = $compData['global_email'];
        $configFile['admin_footer'] = $compData['admin_footer'];
        $configFile['admin_footer_url'] = $compData['admin_footer_url'];
        $configFile['frontend_footer'] = $compData['frontend_footer'];
        $configFile['frontend_footer_url'] = $compData['frontend_footer_url'];
        $configFile['admin_header_logo'] = $compData['admin_header_logo'];
        $configFile['frontend_header_logo'] = $compData['frontend_header_logo'];
        $configFile['admin_favicon'] = $compData['admin_favicon'];
        $configFile['frontend_favicon'] = $compData['frontend_favicon'];


        if (!Factory::toFile($filename, $configFile)) {
            $result = ['result' => false, 'message' => 'Can\'t put content to ' . $filename . 'due to file permission issue.'];
        } else {
            $result = ['result' => true, 'message' => 'Cofiguration content has been set successfully.'];
        }

        if (!$viewModel instanceof JsonModel && $request->isXmlHttpRequest()) {
            $viewModel = new JsonModel();
        }

        $viewModel->setVariables(['data' => $result]);

        return $viewModel;
    }
}
