<?php

namespace Dashboard\Controller;

//use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\{
    ViewModel,
    JsonModel
};
use Dashboard\Form\MarkupForm;
use Dashboard\Form\MarkupAddUserForm;
use Application\Controller\RestAPIClientController;
use Zend\Validator\{
    NotEmpty,
    Digits
};
use Zend\Debug\Debug;
use Dashboard\Model\User;
use Zend\Json\Json;
use Zend\Session\Container;

class MarkupController extends RestAPIClientController {

    public function __construct() {
        $this->userModel = new User();
    }

    /**
     * User Markup Heading
     * @return ViewModel
     */
    public function indexAction() {

        MarkupAddUserForm::$country = $this->userModel->getCountryList();
        MarkupAddUserForm:: $booking_type = $this->getPackageTypeList();
        MarkupAddUserForm:: $user_grade_type = $this->getUserTypeGradeList();
        
        $form = new MarkupAddUserForm();
        $markupListing = [];
        $sessionContainer = new Container('userlogin');
        $userTypeId = $sessionContainer->userTypeId;
        $userId = $sessionContainer->user_id;
       
        $companyId = $this->config()->getConfig()->company->companyId;
        $url = $this->apiUrl() . "/markup/getCompanyMarkup?company_id=" . $companyId."&created_by=".$userId;
        
        $val = $this->get($url);
        $JsonData = $val->getBody();
        $JsonData = Json::decode($JsonData, true);

        if ((!empty($JsonData) && $JsonData['responsedata']['status']=='success')) {
            $markupListing = $JsonData['responsedata']['data'];
        }
        $viewModel = new ViewModel(['form' => $form, 'markupListing' => $markupListing]);
        return $viewModel;
    }

    /**
     * Add Markup Booking
     * @return ViewModel
     */
    public function addMarkupBookingAction() {
      
        MarkupAddUserForm:: $booking_type = $this->getPackageTypeList();

        $markup_type = [
            '1' => 'Fixed',
            '2' => 'percentage',
            '3' => 'Any',
        ];
        MarkupAddUserForm::$markup_type = $markup_type;

        $form = new MarkupAddUserForm();
        $request = $this->getRequest();

        if ($request->isPost()) {
            $post = $request->getPost()->toArray();


            //\Zend\Debug\Debug::dump($post); 

            $form->setData($request->getPost());

            if ($form->isValid()) {
                //echo 'niharika';die;
                return $this->redirect()->toRoute('markup', ['action' => 'index']);
            } else {

                //echo 'aggarwal';die;
                //$msg=$form->getMessages();
                //Debug::dump($msg);
                //die;
            }
        }


        $viewModel = new ViewModel(['form' => $form]);
        return $viewModel;
    }

    /**
     * Add Markup City
     * @return ViewModel
     */
    public function addMarkupCityAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * Add Markup Country
     * @return ViewModel
     */
    public function addMarkupCountryAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * Add Markup User
     * @return ViewModel
     */
    public function addMarkupUserAction() {
        $sessionContainer = new Container('userlogin');
        $userTypeId = $sessionContainer->userTypeId;
        $userId = $sessionContainer->user_id;
        $companyId = $this->config()->getConfig()->company->companyId;

        MarkupAddUserForm::$country = $this->userModel->getCountryList();
        MarkupAddUserForm:: $booking_type = $this->getPackageTypeList();
        MarkupAddUserForm:: $user_grade_type = $this->getUserTypeGradeList();

        $form = new MarkupAddUserForm();
        $request = $this->getRequest();


        if ($request->isPost()) {
            $postData = $request->getPost()->toArray();
            $finalData = [];
            $finalData = [
                
                'user_grade' => $postData['user_grade_type'],
                'company_id' => $companyId,
                'markup_amt_type' => $postData['addmarkupType'],
                'country_id' => $postData['country_id'],
                'markup_category' => $postData['markup'],
                'city_id' => $postData['city_id'],
                'markup_amount' => $postData['markup_amount'],
                'markup_amt_base' => $postData['addmarkupAmountT'],
                'extra_km' => $postData['extra_km'],
                'extra_min' => $postData['extra_min'],
                'master_package_id' => $postData['booking_type'],
                'user_id' => $postData['driver_value'],
                'created_date' => date('Y-m-d'),
                'created_by' => $userId,
            ];
           // echo'<pre>';print_r($finalData);die();
         
            $url = $this->apiUrl() . "/markup/addCompanyMarkup";
            $val = $this->post($url, $finalData);
            $JsonData = $val->getBody();
            $JsonData = Json::decode($JsonData, true);

            if ((!empty($JsonData)) && !isset($JsonData['error'])) {
                $msg = "Markup Details Added Successfully..";

                $this->redirect()->toRoute('markup', ['action' => 'index']);
                $this->flashMessenger()->addMessage(array('success' => $msg));
            } else {
                $msg = "Markup Details Could Not Added Successfully..";
                $this->redirect()->toRoute('markup', ['action' => 'add-markup-user']);
                $this->flashMessenger()->addMessage(array('danger' => $msg));
            }
            $form->setData($request->getPost());

        }

        $viewModel = new ViewModel(['form' => $form]);
       
        return $viewModel;
    }
    
        /**
     * Add Markup User
     * @return ViewModel
     */
    public function editMarkupUserAction() {
       // echo "abc"; die;
        $sessionContainer = new Container('userlogin');
        $userTypeId = $sessionContainer->userTypeId;
        $userId = $sessionContainer->user_id;
        $markupdata =[];
      
        $markupId = $this->params()->fromQuery('id');
        $companyId = $this->params()->fromQuery('company_id');
        
        if ($markupId != '' && $companyId != '') {
            $url = $this->apiUrl() . "/markup/getCompanyMarkup?company_id=".$companyId."&markup_id=".$markupId;
            $val = $this->get($url);
            $JsonData = $val->getBody();
            $JsonData = Json::decode($JsonData, true);
            
            if ((!empty($JsonData['responsedata']) && isset($JsonData['responsedata']['data'][0]))) {
                $markupdata = $JsonData['responsedata']['data'][0];
            }
        }
    
      
        MarkupAddUserForm::$country = $this->userModel->getCountryList();
        MarkupAddUserForm:: $booking_type = $this->getPackageTypeList();
        MarkupAddUserForm:: $user_grade_type = $this->getUserTypeGradeList();
   
        $form = new MarkupAddUserForm();
        $request = $this->getRequest();


        if ($request->isPost()) {
            $postData = $request->getPost()->toArray();
         
            $finalData = [];
            $finalData = [
                'markup_id' => $postData['markup_id'],
                'user_grade' => $postData['user_grade_type'],
                'company_id' => $postData['company_id'],
                'markup_amt_type' => $postData['addmarkupType'],
                'country_id' => $postData['country_id'],
                'markup_category' => $postData['markup'],
                'city_id' => $postData['city_id'],
                'markup_amount' => $postData['markup_amount'],
                'markup_amt_base' => $postData['addmarkupAmountT'],
                'extra_km' => $postData['extra_km'],
                'extra_min' => $postData['extra_min'],
                'master_package_id' => $postData['booking_type'],
                'user_id' => $postData['driver_value'],
                'modified_by' => $userId,
            ];

                $url = $this->apiUrl() . "/markup/updatemarkup"; 
                $val = $this->post($url, $finalData);
                $JsonData = $val->getBody();
                $JsonData = Json::decode($JsonData, true);

            if ((!empty($JsonData)) && !isset($JsonData['error'])) {
                $msg = "Markup Details Updated Successfully..";

                $this->redirect()->toRoute('markup', ['action' => 'index']);
                $this->flashMessenger()->addMessage(array('success' => $msg));
            } else {
                $msg = "Markup Details Could Not Updated Successfully..";
                $this->redirect()->toRoute('markup', ['action' => 'edit-markup-user']);
                $this->flashMessenger()->addMessage(array('danger' => $msg));
            }
            $form->setData($request->getPost());

        }

        $viewModel = new ViewModel(['form' => $form,'markupdata'=>$markupdata]);
        return $viewModel;
    }
    

    /**
     * Markup Middle Links
     * @return ViewModel
     */
    public function markupMiddleLinksAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * Markup Search Booking
     * @return ViewModel
     */
    public function markupSearchBookingAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * Markup Search Country
     * @return ViewModel
     */
    public function markupSearchCountryAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * Markup Search User
     * @return ViewModel
     */
    public function markupSearchUserAction() {
        //write code here...

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     * Markup View Update Records
     * @return ViewModel
     */
    public function filterMarkupDataAction() {
        $companyId = $this->config()->getConfig()->company->companyId;
        $markupListing=[];
        $postData = $this->getRequest()->getPost()->toArray();
        
        $markup=isset($postData['markup']) ? $postData['markup']:'';
        $driver_value=isset($postData['driver_value']) ? $postData['driver_value']:'';
        $user_grade_type=isset($postData['user_grade_type']) ? $postData['user_grade_type']:'';
        $country_id=isset($postData['country_id']) ? $postData['country_id']:'';
        $city_id=isset($postData['city_id']) ? $postData['city_id']:'';
        $booking_type=isset($postData['booking_type']) ? $postData['booking_type']:'';
        $querystr='';
      
        if($companyId!='')
        {
            $querystr.="company_id=".$companyId;
            
        }
        if($markup!='')
        {
            $querystr.="&markp_type=".$markup;
        }
        if($country_id!='')
        {
            $querystr.="&country_id=".$country_id;
        }
        if($city_id!='')
        {
            $querystr.="&city_id=".$city_id;
        }
        if($booking_type!='')
        {
            $querystr.="&master_package_id=".$booking_type;
        }
         if($driver_value!='')
        {
            $querystr.="&user_id=".$driver_value;
        }
         if($user_grade_type!='')
        {
            $querystr.="&user_grade=".$user_grade_type;
        }
      
        $url = $this->apiUrl() . "/markup/getCompanyMarkup?".$querystr;
        
        $resp = $this->get($url);
        $JsonData = Json::decode($resp->getBody(), true);  
        
        if ((!empty($JsonData) && $JsonData['responsedata']['status']=='success')) {
            $markupListing = $JsonData['responsedata']['data'];
        }
        $viewModel = new ViewModel(['markupListing' => $markupListing]);
        $viewModel->setTemplate('/dashboard/markup/markup-listing');
        $viewModel->setTerminal(true);
        return $viewModel;
     
    }

    public function getDriverListAction() {
        $request = $this->getRequest();
        $postdata = $request->getPost();
        $term = $postdata['term'];
        $val = '{"where":{ "and" :[{"first_name":{"like": "' . $term . '%"}},{"user_type_id":"3"}]},"limit":10}';
        $val = rawurlencode($val);
        $url = $this->apiUrl() . "/user?filter=" . $val;
        $resp = $this->get($url);
        $driverJsonData = Json::decode($resp->getBody(), true);
        if (!empty($driverJsonData)) {
            foreach ($driverJsonData as $value) {
                $data[] = ["label" => $value['first_name'], "value" => $value['id']];
            }
        } else {
            $data[] = ["label" => 'Not Exist'];
        }
        $view = new JsonModel($data);
        return $view;
    }
  
    public function getPackageTypeList() {
        $packageTypeJsonDataArray = [];
        $url = $this->apiUrl() . "/package";
        $resp = $this->get($url);
        $packageTypeJsonData = Json::decode($resp->getBody(), true);
        foreach ($packageTypeJsonData['data'] as $res) {
            $packageTypeJsonDataArray[$res['id']] = $res['name'];
        }
        return $packageTypeJsonDataArray;
    }

    public function getUserTypeGradeList() {
        $gradeTypeJsonDataArray = [];
        $url = $this->apiUrl() . "/user-grade";
        $resp = $this->get($url);
        $gradeTypeJsonData = Json::decode($resp->getBody(), true);

        foreach ($gradeTypeJsonData as $res) {
            $gradeTypeJsonDataArray[$res['id']] = $res['grade_name'];
        }

        return $gradeTypeJsonDataArray;
    }
    
    public function deleteMarkupAction() {
        
        $id = $this->params()->fromQuery('data');
        $data = ['id' => $id];
        $url = $this->apiUrl() . "/markup/deleteMarkup?id=".$data['id'];;
        $resp = $this->get($url);
        $cityJsonData = Json::decode($resp->getBody(), true);
        $this->redirect()->toRoute('markup', ['action' => 'index']);
       
    }
    

}
