<?php

namespace Dashboard\Form;

use Zend\Form\Form;
use Zend\Form\Element;
use Zend\Form\Element\Select;
use Zend\Form\Element\File;
use Zend\Form\Element\Text;
use Zend\Form\Element\Radio;
use Zend\Form\Element\Submit;
use Zend\Form\Element\Checkbox;
use Zend\Form\Element\Email;
use Zend\Form\Element\Textarea;
use Zend\Form\Element\Date;

class StatementOfAccountForm extends Form {
    public static $bookingStatus = [];

    public function __construct($name = null) {

        parent::__construct('statement-of-account-form');
        $this->setAttribute('method', 'post');
        
        /**
         * 
         * Payment ID
         */
        $this->add([
            'name' => 'payment_id',
            'type' => Text::class,
            'attributes' => [
                'id' => 'payment-id',
                'placeholder' => 'Payment ID',
                'class' => 'form-control inputchange'
            ],
            'options' => [
                'label' => 'Payment ID<span style="color: red"> *</span>',
                'label_options' => ['disable_html_escape' => true]
            ],
        ]);

        /**
         * From Date
         */
        $this->add([
            'name' => 'start_date',
            'type' => text::class,
            'attributes' => [
                'id' => 'start-date',
                'class' => 'form-control inputchange datepicker'
            ],
            'options' => [
                'label' => 'From Date<span style="color: red"> *</span>',
                'label_options' => ['disable_html_escape' => true]
            ],
        ]);

        /**
         * To Date
         */
        $this->add([
            'name' => 'end_date',
            'type' => text::class,
            'attributes' => [
                'id' => 'end-date',                
                'class' => 'form-control inputchange datepicker'
            ],
            'options' => [
                'label' => 'To<span style="color: red"> *</span>',
                'label_options' => ['disable_html_escape' => true]
            ],
        ]);  
        
        /**
         * Booking Status
         */
        $this->add([
            'name' => 'booking_status',
            'type' => Select::class,
            'attributes' => [
                'id' => 'booking-status',                
                'class' => 'form-control'
            ],
            'options' => [
                'label' => 'Booking Status',
                'value_options' => self::$bookingStatus
            ]
            
        ]);
        
        /**
         * Search
         */
        $this->add([
            'name' => 'search',
            'type' => Submit::class,
            'attributes' => [
                'value' => 'Search',
                'id' => 'search',
                'class' => 'btn btn-primary btn-lg'
            ],
        ]);   
        
        /**
         * Clear
         */
        $this->add([
            'name' => 'clear',
            'type' => Submit::class,
            'attributes' => [
                'value' => 'Clear',
                'id' => 'clear',
                'class' => 'btn btn-primary btn-lg'
            ],
        ]); 
    }

}
