<?php

namespace User\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\JsonModel;
use Zend\Debug\Debug;
use Zend\View\Model\ViewModel;
use User\Form\{
    LoginForm,
    PopupRegistrationForm,
    ConfirmOtpForm,
    ConfirmLoginOtpForm
};
use Zend\Form\Element\Submit;
use Application\Controller\RestAPIClientController;
use Zend\Validator\{
    NotEmpty,
    Digits
};
use Zend\Session\Container;
use Zend\Json\Json;
use \Zend\Validator\StringLength;
use Zend\Config\Config;
use Zend\Config\Factory;

class IndexController extends RestAPIClientController {

    public function indexAction() {


        $viewModel = new ViewModel();
        return $viewModel;
    }

    public function affilateRegistrationAction() {
        $viewModel = new ViewModel();
        return $viewModel;
    }

    public function registrationCompleteAction() {

        $viewModel = new ViewModel();
        return $viewModel;
    }

    /**
     *
     * @return ViewModel
     */
    public function loginActionOld() {

        $loginForm = new LoginForm();
        $request = $this->getRequest();
        //echo "niharika";die;

        if ($request->isPost()) {
            $post = $request->getPost()->toArray();

            // $post = $request->getPost()->toArray();

            if ($loginForm->isValid()) {

                $password = md5($post['password']);
                $userName = $post['username'];
                $valid_mobile = preg_match('/^[0-9]{10}+$/', $username);
                $validate_email = filter_var($username, FILTER_VALIDATE_EMAIL);

                if ($valid_mobile) {
                    $validator = new StringLength();
                    $validator->setMin(10);
                    $validator->setMax(10);
                    $valide_mobile = $validator->isValid("$username");
                }


                if ($valide_mobile || $validate_email) {


                    $password = $loginData['password'];
                    $validator = new StringLength();
                    $validator->setMin(6);
                    $validator->setMax(20);
                    $valid = $validator->isValid("$password");

                    if ($valid) {

                        $finalData = [
                            'username' => $userName,
                            'password' => $password
                        ];

                        $url = $this->apiAdminUrl() . "auth/login";
                        $val = $this->post($url, $finalData);
                        $JsonData = $val->getBody();
                        $JsonData = Json::decode($locationJsonData, true);

                        if ((!empty($JsonData)) && (!$JsonData['error'])) {

                            $status = $JsonData["status"];
                            if ($status == true) {
                                $this->redirect()->toRoute('dashboard', ['action' => 'index']);
                            } else {
                                $msg = "username and password are not matched";
                            }
                        }
                    } else {
                        $msg = "password should be greater than 6 and smaller than 20";
                    }
                } else {
                    $msg = "Username should be valid Mobil no. or valid emailid";
                }
                $data = $this->redirectfunc($JsonData);
                $jsonModel = new JsonModel($data);
                return $jsonModel;
                exit();
            } else {
                return new JsonModel(['error' => $JsonData['error']]);
                exit();
            }

//            if($userName!='' && $password!=''){
//                $url = $this->apiUrl()."auth/login";
//                $val = $this->post($url, $finalData);
//                $locationJsonData = $val->getBody();
//                $locationJsonData = Json::decode($locationJsonData, true);
//
//                echo '<pre>';print_r($locationJsonData);die;
//
//              if (!empty($locationJsonData) && !$locationJsonData['error']) {
//                  $data  = $this->redirectfunc($locationJsonData);
//                  $jsonModel = new JsonModel($data);
//                  return $jsonModel;
//                  exit();
//               }else{
//                  return new JsonModel(['error' =>$locationJsonData['error']]);
//                  exit();
//               }
//           }
        }
        $viewModel = new ViewModel(['form' => $loginForm]);
        // $viewModel->setTemplate('/user/login/login');
        $viewModel->setTerminal(true);

        return $viewModel;
    }

    public function loginOldMohitAction() {
        $loginForm = new LoginForm();
        $request = $this->getRequest();

        /////////////////


        if ($request->isPost()) {
            $result = [];

            if ($request->isXmlHttpRequest()) {


                $loginForm->setData($request->getPost());
                $post = $request->getPost()->toArray();

                if ($loginForm->isValid()) {

                    $post['password'] = md5($post['password']);
                    $data = $this->userLogin($post);

                    if (isset($data['data']['responsedata']['error']) && $data['data']['responsedata']['error']) {
                        $errorMsg = $data['data']['responsedata']['error'];
                        $result = ['status' => 'error1', 'msg' => $errorMsg];
                        $view = new JsonModel($result);
                        return $view;
                    } elseif ($data['status'] == 000) {
                        $result = ['status' => 'error1', 'msg' => $data['data']];
                        $view = new JsonModel($result);
                        return $view;
                    } else {
                        $sessionUser = new Container('userlogin');
                        //$sessionUser->userData = $data['data']['responsedata'];
                        $sessionUser->user_id = $data['data']['responsedata']['user_id'];
                        $user_id = $data['data']['responsedata']['user_id'];
                        $url = $this->apiUrl() . "/user/userpersonalinfo?user_id=" . $user_id;
                        $resp = $this->get($url);
                        $response = Json::decode($resp->getBody(), true);
                        $sessionUser->userData = $response['responsedata']['data'];
                        $result = ['status' => 'success'];
                        $view = new JsonModel($result);
                        return $view;
                    }
                } else {

                    $result = ['status' => 'error', 'msg' => $loginForm->getMessages()];
                    $view = new JsonModel($result);
                    return $view;
                }
            }
        }





        ////////////

        $viewModel = new ViewModel(['form' => $loginForm]);
        $viewModel->setTerminal(true);

        return $viewModel;
    }

    public function loginAction() {
        $loginForm = new LoginForm();
        $request = $this->getRequest();
        $otpform = new ConfirmLoginOtpForm();
        /////////////////


        if ($request->isPost()) {
            $result = [];

            if ($request->isXmlHttpRequest()) {


                $loginForm->setData($request->getPost());
                $post = $request->getPost()->toArray();

                if ($loginForm->isValid()) {

                    $post['password'] = ($post['password']);
                    $post['sms_send_status'] = "true";
                    $data = $this->userLogin($post);
                    //echo '<pre>';print_r($data);die();
                    if (isset($data['error']) && $data['error']) {
                        $errorMsg = $data['error'];
                        $result = ['status' => 'error1', 'msg' => $errorMsg];
                        $view = new JsonModel($result);
                        return $view;
                    } elseif ($data['status'] == 000) {
                        $result = ['status' => 'error1', 'msg' => $data['error']];
                        $view = new JsonModel($result);
                        return $view;
                    } else {
                        $userTypeArr = $this->config()->getConfig()->loginUserType;
                        $userTypeArr = $userTypeArr->toArray();
                        $user_type_id = $data['data']['user_type_id'];
                        if(in_array($user_type_id, $userTypeArr)){
                        $sessionUser = new Container('confirmuserlogin');
                        $sessionUser->user_id = $data['data']['user_id'];
                        $user_id = $data['data']['user_id'];
                        $mobile = $data['data']['mobile'];
                        $first_name = $data['data']['first_name'];
                        $sessionUser->user_token=$data['data']['token'];

                        //Send SMS To user
                        $otp = $this->generateOtp();
                        $templateName = 'acc_verify_code';

                        $smsparam = ['template_name' => $templateName, 'mobile' => $mobile, 'user_name' => $first_name, 'otp' => $otp];

                        $this->sendTxtMsg($smsparam);
                        /* End */


                        // Insert OTP in database
                        $otpData = ['UID' => $user_id, 'Verification_code' => $otp];
                        $this->insertOtp($otpData);
                        /// END

                        $result = ['status' => 'success'];
                        }else{
                        $result = ['status' => 'error1', 'msg' => 'Unauthorized-Access'];
                        }
                        $view = new JsonModel($result);
                        return $view;
                    }
                } else {

                    $result = ['status' => 'error', 'msg' => $loginForm->getMessages()];
                    $view = new JsonModel($result);
                    return $view;
                }
            }
        }

        $viewModel = new ViewModel(['form' => $loginForm,'otpform'=>$otpform]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    public function confirmLoginOtpAction() {
        $sessionUserLogin = new Container('confirmuserlogin');
        $user_id = $sessionUserLogin->user_id;
        $token = $sessionUserLogin->user_token;
//        if ($user_id == "") {
//            return $this->redirect()->toRoute('home');
//        }
        $otpform = new ConfirmLoginOtpForm();
        $request = $this->getRequest();
        /////////////////
        if ($request->isPost()) {
            $result = [];
            if ($request->isXmlHttpRequest()) {
                $otpform->setData($request->getPost());
                $post = $request->getPost()->toArray();
                //echo '<pre>';print_r($post);die();
                //if($post['confirm_otp'])
                if($post['type']=='confirm'){

                if ($otpform->isValid()) {
                    $data = [
                        'user_id' => $user_id,
                        'confirm_otp' => $post['confirm_otp']
                    ];
                    //echo '<pre>';print_r($data);die();
                    $rep = $this->fetchOtp($data);
                    //echo '<pre>';print_r($rep);die();
                    if ($rep['status'] == "success") {
                        //unset($sessionUserLogin->user_id);
                        $sessionUser = new Container('userlogin');
                        $sessionUser->user_id = $user_id;
                        $sessionUser->user_token = $token;

                        $url = $this->apiUrl() . "/user/userpersonalinfo?user_id=" . $user_id;
                        $resp = $this->get($url);
                        $response = Json::decode($resp->getBody(), true);
                        $sessionUser->userData = $response['responsedata']['data'];
                        $data = ['id' => $rep['data']['id'], 'UID' => $rep['data']['UID'], 'Verification_code' => $rep['data']['Verification_code'], 'isUsed' => 1];
                        $this->updateOtp($data);
                        $result = ['status' => 'success'];
                        $view = new JsonModel($result);
                        return $view;
                    } else {
                        $msg = "Please enter the correct OTP";
                        $response = array();
                        $response["confirm_otp"] = array($msg);
                        $result = ['status' => 'error', 'msg' => $response];
                        $view = new JsonModel($result);
                        return $view;
                    }
                } else {
                    $result = ['status' => 'error', 'msg' => $otpform->getMessages()];
                    $view = new JsonModel($result);
                    return $view;
                }
                }else {


                        $url = $this->apiUrl() . "/user/userpersonalinfo?user_id=" . $user_id;
                        $resp = $this->get($url);
                        $response = Json::decode($resp->getBody(), true);
                        $data   =   $response['responsedata']['data'];

                        $id = $this->config()->getConfig()->company->companyId;
                        $compJsonData = $this->getCompanySetupDetails($id);

                        //echo '<pre>';print_r($compJsonData);die();
                        $otp = $this->generateOtp();
                        $smsparam = [
                            'template_name' => 'acc_verify_code',
                            'user_id'=> $data['user_id'],
                            'mobile' => $data['mobile'],
                            //'mobile' => '9313504429',
                            'user_name' => $data['first_name'],
                            'otp' => $otp,
                            'company_name' => $compJsonData['com_name'],
                            'site_url'=>$compJsonData['site_url'],
                            'sms_param' =>[$data['first_name'],$compJsonData['com_name'],$compJsonData['site_url']]
                        ];

                        //echo '<pre>';print_r($smsparam);die();
                        $this->sendResendOtp($smsparam);
                        //$this->sendTxtMsg($smsparam);
                        //$otpData = ['UID' => $user_id, 'Verification_code' => $otp];
                        //$this->insertOtp($otpData);
                        $msg = "OTP Resend Successfully";
                        $result = ['status' => 'success', 'msg' => $msg];
                        $view = new JsonModel($result);
                        return $view;
                        /// END

                }
            }
        }

        $viewModel = new ViewModel(['otpform' => $otpform]);
        $viewModel->setTerminal(true);
        return $viewModel;
    }

    /* public function loginSearchAction() {
      $loginForm = new LoginForm();
      PopupRegistrationForm:: $nationalityList = $this->getCountryList();
      $personalInfoForm = new PopupRegistrationForm();
      $otpform = new ConfirmOtpForm();
      $request = $this->getRequest();

      /////////////////


      if ($request->isPost()) {
      $result = [];

      if ($request->isXmlHttpRequest()) {
      print_r($request->getPost()); die;
      $loginForm->setData($request->getPost());
      $post = $request->getPost()->toArray();

      if ($loginForm->isValid()) {

      $post['password'] = md5($post['password']);
      $data = $this->userLogin($post);

      if ($data['data']['responsedata']['status'] == true) {
      $sessionUser = new Container('userlogin');
      $sessionUser->userData = $data['data']['responsedata'];
      $sessionUser->user_id = $data['data']['responsedata']['user_id'];
      //$this->setconfiguration();
      $result = ['status' => 'success'];
      $view = new JsonModel($result);
      return $view;
      } else {
      $errorMsg = $data['data']['responsedata']['error'];

      $result = ['status' => 'error1', 'msg' => $errorMsg];
      $view = new JsonModel($result);
      return $view;
      }
      } else {
      //Debug::dump($loginForm->getMessages());
      $result = ['status' => 'error', 'msg' => $loginForm->getMessages()];
      $view = new JsonModel($result);
      return $view;
      }
      }
      }

      $viewModel = new ViewModel(['form' => $loginForm, 'personalform' => $personalInfoForm, 'otpform' => $otpform]);
      $viewModel->setTerminal(true);

      return $viewModel;
      } */

    public function redirectfunc($locationJsonData) {
        if (!empty($locationJsonData[userdata][0])) {

            $user_type_id = $locationJsonData[userdata][0]['user_type_id'];
            $user_id = $locationJsonData[userdata][0]['id'];
            $phone_no = $locationJsonData[userdata][0]['mobile'];
            $first_name = $locationJsonData[userdata][0]['first_name'];
            $email = $locationJsonData[userdata][0]['email'];

            $sessionContainer = new Container('login_redirect');
            $sessionContainer->user_type_id = $user_type_id;
            $sessionContainer->user_id = $user_id;
            $sessionContainer->phone_no = $phone_no;
            $sessionContainer->first_name = $first_name;
            $sessionContainer->email = $email;
        }

        if ($user_type_id == 1 || $user_type_id == 2 || $user_type_id == 3) {
            return $return = ['redirect' => 'dashboard'];
        }
    }

    public function logoutAction() {
        $sessionUser = new Container('userlogin');
        $user_tokendata=$this->userToken();
        //echo'<pre>';print_r($user_tokendata);die();

        unset($sessionUser->userData);
        return $this->redirect()->toRoute('home');
    }

    public function userLogin($data) {
        $val = [];

        $url = $this->apiUrl() . "/user/login";
        $resp = $this->post($url, $data);
        $response = Json::decode($resp->getBody(), true);

//        if(isset($response['response_status']) && !empty($response['response_status'])){
//            return  $val = ["status" => $response['response_status']['status'], "data" =>$response['response_status']['message']];
//        }

        $responseStatus = $response['responsedata']['status'];

        if ($responseStatus == "success") {
            $val = ["status" => true, "data" => $response['responsedata']['data']];
        } else {
            $val = ["status" => false, "error" => $response['responsedata']['error']];
        }
        return $val;
        //Debug::dump($response);
        //exit;
    }

    public function setconfiguration() {
        $sessionUser = new Container('userlogin');
        $loginData = $sessionUser->userData;
        $user_id = $loginData['user_id'];
        $comp_id = $loginData['company_id'];
        $compData = $this->getCompanySetupDetails($comp_id);
        //echo '<pre>';print_r($compData);//die();
        $filename = getcwd() . '/config/autoload/customconfig.php';
        $configFile = Factory::fromFile($filename);
        $configFile['site_name'] = $compData['site_name'];
        $configFile['site_title'] = $compData['site_title'];
        $configFile['global_email'] = $compData['global_email'];
        $configFile['admin_footer'] = $compData['admin_footer'];
        $configFile['admin_footer_url'] = $compData['admin_footer_url'];
        $configFile['frontend_footer'] = $compData['frontend_footer'];
        $configFile['frontend_footer_url'] = $compData['frontend_footer_url'];
        $configFile['admin_header_logo'] = $compData['admin_header_logo'];
        $configFile['frontend_header_logo'] = $compData['frontend_header_logo'];
        $configFile['admin_favicon'] = $compData['admin_favicon'];
        $configFile['frontend_favicon'] = $compData['frontend_favicon'];


        if (!Factory::toFile($filename, $configFile)) {
            $result = ['result' => false, 'message' => 'Can\'t put content to ' . $filename . 'due to file permission issue.'];
        } else {
            $result = ['result' => true, 'message' => 'Cofiguration content has been set successfully.'];
        }
        return $result;
    }

    public function getCountryList() {
        $countryJsonDataArray = [];
        $url = $this->apiUrl() . "/country";
        $resp = $this->get($url);
        $countryJsonData = Json::decode($resp->getBody(), true);
        foreach ($countryJsonData as $res) {
            $countryJsonDataArray[$res['id']] = $res['name'];
        }
        return $countryJsonDataArray;
    }

    /* @type : text */

    public function insertOtp($data) {
        $url = $this->apiUrl() . "/activation";
        $resp = $this->post($url, $data);
        $response = Json::decode($resp->getBody(), true);
        //Debug::dump($response);
        //exit;
        return $response;
    }

    public function sendTxtMsg($paramData = array()) {
        $smsparam = ['template_name' => $paramData['template_name'], 'mobile' => $paramData['mobile'], 'user_name' => $paramData['user_name'], 'otp' => $paramData['otp']];
        //Debug::dump($smsparam); exit;
        $this->sendSMS($smsparam);
    }

    public function fetchOtp($data) {
        $user_id = $data['user_id'];
        $otp = $data['confirm_otp'];
        $val = '{"where":{"and": [{"UID": "' . $user_id . '"},{"Verification_code": "' . $otp . '"},{"isUsed": 0}]}}';
        $val = rawurlencode($val);
        $url = $this->apiUrl() . "/activation?&filter=" . $val;
        $resp = $this->get($url);
        $response = Json::decode($resp->getBody(), true);
        return $response;
    }

    public function updateOtp($data) {
        $url = $this->apiUrl() . "/activation";
        $resp = $this->put($url, $data);
        $response = Json::decode($resp->getBody(), true);
        //Debug::dump($response);
        //exit;
        return $response;
    }

    /** @Description  : Dashboard Login
     *  @createdDate  : 03-May-2019
     *  */
    public function dashboardLoginAction(){
       $sessionUser = new Container('userlogin');
       $user_id = $sessionUser->userData['user_id'];
       if($user_id!=""){
           $this->redirect()->toRoute('dashboard');
       }
       $errorMsg="";
       $captchaerror = '';
       $form = new LoginForm();
       $request = $this->getRequest();
        if ($request->isPost()) {
            $post = $request->getPost()->toArray();
            $form->setData($request->getPost());
            if ($post['g-recaptcha-response'] == '') {
                    $captchaerror = 'Please check the captcha';
                }
            //$form->getInputFilter()->get('user_type_id')->setRequired(false);
            if ($form->isValid() && $captchaerror == '') {
                $post['password'] = ($post['password']);
                $post['sms_send_status'] = "false";
                    $data = $this->userLogin($post);
                    //echo '<pre>';print_r($data);//die();
                    if (isset($data['error']) && $data['error']) {
                        $errorMsg = $data['error'];
                    } elseif ($data['status'] == 000) {
                        $errorMsg = $data['error'];
                    } else {
                        $userTypeArr = $this->config()->getConfig()->loginUserType;
                        $userTypeArr = $userTypeArr->toArray();
                        $user_type_id = $data['data']['user_type_id'];

                        if(!in_array($user_type_id, $userTypeArr)){
                        $sessionUser = new Container('userlogin');
                        $sessionUser->user_id = $data['data']['user_id'];
                        $sessionUser->user_token=$data['data']['token'];

                        $user_id = $data['data']['user_id'];
                        $url = $this->apiUrl() . "/user/userpersonalinfo?user_id=" . $user_id;
                        $resp = $this->get($url);
                        $response = Json::decode($resp->getBody(), true);
                        $sessionUser->userData = $response['responsedata']['data'];
                        $this->redirect()->toRoute('dashboard');
                        }else{
                         $errorMsg = 'Unauthorized-Access';
                        }
                    }
            }else{
                //$msg=$form->getMessages();
                //echo '<pre>';print_r($msg);die();
            }
        }

       $viewModel = new ViewModel([
           'form' => $form,
           'errorMsg'=>$errorMsg,
           'error' => $captchaerror,
           'captchaKey' => $this->config()->getConfig()->googleCaptcha->siteKey
       ]);
       //$this->layout()
       $viewModel->setTerminal(true);
       return $viewModel;
    }


    public function sendResendOtp($data) {
        $url = $this->apiUrl() . "/user/sendSms";
        $resp = $this->post($url, $data);
        $response = Json::decode($resp->getBody(), true);
        return $response;
    }

     /** @Description  : Dashboard Login
     *  @createdDate  : 03-May-2019
     *  */
    public function supplierAction(){
       $sessionUser = new Container('userlogin');
       $user_id = $sessionUser->userData['user_id'];
       if($user_id!=""){
           $this->redirect()->toRoute('dashboard');
       }
       $viewModel = new ViewModel();
       $viewModel->setTerminal(true);
       return $viewModel;
    }


    public function userToken(){
        $sessionUser = new Container('userlogin');
        $userid=$sessionUser->userData['user_id'];
        $user_token = $sessionUser->user_token;
        if($user_token!=''&& $userid!=''){
            $url = $this->apiUrl() . "/user/logout?user_id=".$userid."&token=".$user_token."&logout_location=abc";
            $resp = $this->get($url);
            $response = Json::decode($resp->getBody(), true);
             return $response;
        }
    }


}